DefaultLinkGenerator (Grails 3.3.8)
Date: 2018-08-10

Package: org.grails.web.mapping

## [Groovy] Class DefaultLinkGenerator

- org.grails.web.mapping.DefaultLinkGenerator

- All Implemented Interfaces and Traits:
    LinkGenerator, PluginManagerAware

      @groovy.transform.CompileStatic
      class DefaultLinkGenerator
      extends java.lang.Object

  A link generating service for applications to use when generating links.

  Authors:
    Graeme Rocher
  Since:
    2.0

- - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `java.lang.String` | `configuredServerBaseURL`
    `java.lang.String` | `contextPath`
    `UrlConverter` | `grailsUrlConverter`
    `org.grails.datastore.mapping.model.MappingContext` | `mappingContext`
    `GrailsPluginManager` | `pluginManager`
    `GrailsRequestStateLookupStrategy` | `requestStateLookupStrategy`
    `java.lang.String` | `resourcePath`
    `java.lang.String` | `resourcePattern`
    `UrlMappingsHolder` | `urlMappingsHolder`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `DefaultLinkGenerator (java.lang.String serverBaseURL, java.lang.String contextPath)`
    `DefaultLinkGenerator (java.lang.String serverBaseURL)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `java.lang.String` | `getContextPath()`
    `` | `protected java.lang.String` | `getResourceId(java.lang.Object resourceAttribute)`
    `` | `java.lang.String` | `getServerBaseURL()`
    `` | `void` | `initializeResourcePath()`
    `` | `protected boolean` | `isAbsolute(java.util.Map attrs)`
    `` | `java.lang.String` | `link(java.util.Map attrs, java.lang.String encoding = 'UTF-8')` ')) { resourcePath = resourcePattern.substring(0, resourcePattern.length() - 3) } }
    `` | `java.lang.String` | `makeServerURL()` Get the declared URL of the server from config, or guess at localhost for non-production.
    `` | `java.lang.String` | `resource(java.util.Map attrs)` {@inheritDoc }
    `` | `void` | `setPluginManager(GrailsPluginManager pluginManager)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Property Detail

    - #### java.lang.String configuredServerBaseURL

    - #### java.lang.String contextPath

    - #### @org.springframework.beans.factory.annotation.Autowired(required = false) UrlConverter grailsUrlConverter

    - #### @org.springframework.beans.factory.annotation.Autowired(required=false) @org.springframework.beans.factory.annotation.Qualifier('grailsDomainClassMappingContext') org.grails.datastore.mapping.model.MappingContext mappingContext

    - #### GrailsPluginManager pluginManager

    - #### GrailsRequestStateLookupStrategy requestStateLookupStrategy

    - #### java.lang.String resourcePath

    - #### @org.springframework.beans.factory.annotation.Value('${grails.resources.pattern:/static/**}') java.lang.String resourcePattern

    - #### @org.springframework.beans.factory.annotation.Autowired @org.springframework.beans.factory.annotation.Qualifier("grailsUrlMappingsHolder") UrlMappingsHolder urlMappingsHolder

  - ### Constructor Detail

    - #### DefaultLinkGenerator(java.lang.String serverBaseURL, java.lang.String contextPath)

    - #### DefaultLinkGenerator(java.lang.String serverBaseURL)

  - ### Method Detail

    - #### java.lang.String getContextPath()

    - #### @groovy.transform.CompileStatic(TypeCheckingMode.SKIP) protected java.lang.String getResourceId(java.lang.Object resourceAttribute)

    - #### java.lang.String getServerBaseURL()

    - #### @javax.annotation.PostConstruct void initializeResourcePath()

    - #### protected boolean isAbsolute(java.util.Map attrs)

    - #### java.lang.String link(java.util.Map attrs, java.lang.String encoding = 'UTF-8')

      ')) { resourcePath = resourcePattern.substring(0, resourcePattern.length() - 3) } } /** {@inheritDoc}

    - #### java.lang.String makeServerURL()

      Get the declared URL of the server from config, or guess at localhost for non-production.

    - #### java.lang.String resource(java.util.Map attrs)

      {

      inheritDoc:
        }

    - #### void setPluginManager(GrailsPluginManager pluginManager)